import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'vitalHealthExamBooking.m.dart';

import 'liveConsultation.m.dart';


class VitalHealthExamBookingService extends JsonRpcClientBase {
	VitalHealthExamBookingService(
		String host, {
		String serviceName = "IVitalHealthExamBookingService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => PageResult<HealthExamBookingDTO>.fromJson(map));
		FJsonConvert.setDecoder((map) => HealthExamBookingDTO.fromJson(map));
	}

	Future<PageResult<HealthExamBookingDTO>> getHealthExamBookingPageAsync(GetHealthExamBookingPageRequest request) async {
		var rpcRst = await call("GetHealthExamBookingPageAsync", request);
		var result = PageResult<HealthExamBookingDTO>.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<String> saveHealthExamBookingAsync(SaveHealthExamBookingRequest request) async {
		var rpcRst = await call("SaveHealthExamBookingAsync", request);
		return rpcRst;
	}

	Future<HealthExamBookingDTO> getHealthExamBookingAsync(GetHealthExamBookingRequest request) async {
		var rpcRst = await call("GetHealthExamBookingAsync", request);
		var result = HealthExamBookingDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<bool> deleteHealthExamBookingAsync(DeleteHealthExamBookingRequest request) async {
		var rpcRst = await call("DeleteHealthExamBookingAsync", request);
		return rpcRst;
	}

	Future<bool> signUpASync(SignUpHealthExamBookingRequest request) async {
		var rpcRst = await call("SignUpASync", request);
		return rpcRst;
	}

}

